Summary: A SQL database engine
Name: mysql
Group: Trustix Official
Version: 4.0.24
Release: 1tr
License: GPL / LGPL
%define shared_libversion	12:0:0
%define mysqld_user		mysql
Source: http://mirrors.sunsite.dk/mysql/Downloads/MySQL-4.0/mysql-%{version}.tar.gz
Source2: mysql.init
Source3: mysql.conf
URL: http://www.mysql.com/
Provides: msqlormysql MySQL-server
Buildroot: /var/tmp/%{name}-root
BuildRequires: bison, texinfo, python, gcc-c++-devel, zlib-devel
BuildREquires: db4-devel, libtermcap-devel, openssl-devel, ncurses-devel
Requires: mysql-shared mysql-libs
Prereq: /bin/hostname /bin/sleep /sbin/chkconfig /sbin/restart_maybe htmlinfo
%define see_base For a description of MySQL see the base MySQL RPM or http://www.mysql.com


# From the manual
%description
MySQL is a true multi-user, multi-threaded SQL (Structured Query
Language) database server. MySQL is a client/server implementation
that consists of a server daemon (mysqld) and many different client
programs/libraries.

The main goals of MySQL are speed, robustness and ease of use.

The base upon which MySQL is built is a set of routines that have been
used in a highly demanding production environment for many
years. While MySQL is still in development, it already offers a rich
and highly useful function set.

See the documentation for more information

%package client
Summary: MySQL - Client
Group: Trustix Official
Requires: mysql-shared mysql-libs

%description client
This package contains the standard MySQL clients. 

%{see_base}

%package bench
Requires: mysql-client perl
Summary: MySQL - Benchmarks and test system
Group: Trustix Official

%description bench
This package contains MySQL benchmark scripts and data.

%{see_base}

%package devel
Requires: mysql-libs
Summary: MySQL - Development header files and libraries
Group: Trustix Official

%description devel
This package contains the development header files and libraries
necessary to develop MySQL client applications.

%{see_base}

%package libs
Summary: MySQL - Shared libraries
Group: Trustix Official

%description libs
This package contains the shared libraries (*.so*) which certain
languages and applications need to dynamically load and use MySQL.

%package shared
Summary: MySQL - Shared executables.
Group: Trustix Official
Requires: mysql-libs

%description shared
This package contains the shared binaries that is used both by the
MySQL client and server.

%prep
%setup -q -n %{name}-%{version}

%build
PATH="${MYSQL_BUILD_PATH:-/bin:/usr/bin}" \
CC="${MYSQL_BUILD_CC:-gcc}" \
CFLAGS="${MYSQL_BUILD_CFLAGS:- $RPM_OPT_FLAGS}" \
CXX="${MYSQL_BUILD_CXX:-gcc}" \
CXXFLAGS="${MYSQL_BUILD_CXXFLAGS:- $RPM_OPT_FLAGS -felide-constructors -fno-exceptions -fno-rtti}" \
./configure \
	    --enable-assembler \
	    --enable-local-infile \
	    --enable-shared \
	    --enable-thread-safe-client \
	    --with-berkeley-db \
	    --with-comment="Trustix MySQL RPM" \
	    --with-extra-charsets=complex \
	    --with-innodb \
	    --with-raid \
  	    --with-openssl \
  	    --with-readline \
            --datadir=/usr/share \
            --exec-prefix=/usr \
            --includedir=/usr/include \
            --infodir=%{_infodir} \
            --libexecdir=/usr/sbin \
            --localstatedir=/var/lib/mysql \
            --mandir=%{_mandir} \
            --prefix=/ \
            --sysconfdir=/etc \
            --with-mysqld-user=%{mysqld_user} \
            --with-unix-socket-path=/var/run/mysql/mysql.sock \
            # Does not work as of MySQL 4.0.12
	    # --with-libwrap
	    # Add this for more debugging support
	    # --with-debug


make benchdir_root=$RPM_BUILD_ROOT/usr/share/
## seperate symbold from mysqld (for debugging) [bg]
#nm --numeric-sort sql/mysqld > sql/mysqld.sym

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
RBR=$RPM_BUILD_ROOT
MBD=$RPM_BUILD_DIR/mysql-%{version}
# Ensure that needed directories exists
install -d $RBR/etc/logrotate.d
install -d $RBR%{_initdir}
install -d $RBR/var/lib/mysql/mysql
install -d $RBR/usr/share/sql-bench
install -d $RBR/usr/share/mysql-test
install -d $RBR/usr/{sbin,share,man,include}
install -d $RBR/usr/doc/MySQL-%{version}
install -d $RBR/usr/lib
## Save shared libraries (with debugging information) [bg]
#(cd libmysql/.libs; tar cf $RBR/shared-libs.tar *.so*)
#(cd libmysql_r/.libs; tar rf $RBR/shared-libs.tar *.so*)

# Make install
make install-strip DESTDIR=$RBR benchdir_root=/usr/share/

# Install logrotate and autostart
install -m644 $MBD/support-files/mysql-log-rotate $RBR/etc/logrotate.d/mysql
install -m755 %{SOURCE2} $RBR%{_initdir}/mysql
install -m600 %{SOURCE3} $RBR/etc/my.cnf

## Install debugging symbols [bg]
#install -m644 sql/mysqld.sym $RBR/usr/lib/mysql/mysqld.sym

## restore shared libs (with debug info) [bg]
#(cd $RBR/usr/lib; tar xf $RBR/shared-libs.tar)
# move libs to /usr/lib/
mv $RBR/usr/lib/mysql/* $RBR/usr/lib/

pushd Docs
#  makeinfo --html --no-split manual.texi
  install -d -m755 $RBR/usr/share/html/%{name}
#  install -m644 mysql.html $RBR/usr/share/html/%{name}/
popd

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%pre
if test -x %{_initdir}/mysql
then
  %{_initdir}/mysql stop > /dev/null 2>&1
  echo "Giving mysqld a couple of seconds to exit nicely"
  sleep 5
fi

%post
mysql_datadir=/var/lib/mysql

# Create data directory if needed
if test ! -d $mysql_datadir;		then mkdir $mysql_datadir; fi
if test ! -d $mysql_datadir/mysql;	then mkdir $mysql_datadir/mysql; fi
if test ! -d $mysql_datadir/test;	then mkdir $mysql_datadir/test; fi

# Add mysql to the chkconfig overview
/sbin/chkconfig --add mysql

# Check whether we need to add mysql group
if [ -z "`getent group %{mysqld_user}`" ] ; then
        /usr/sbin/groupadd  -g 101 %{mysqld_user}
fi

# Check whether we need to add mysql user
if [ -z "`getent passwd %{mysqld_user}`" ] ; then
        /usr/sbin/useradd  -u 101 -m -g %{mysqld_user} -d $mysql_datadir \
	-s /bin/bash -c "MySQL server" %{mysqld_user}
fi

# Change permissions so that the user that will run the MySQL daemon
# owns all database files.
chown -R %{mysqld_user}.%{mysqld_user} $mysql_datadir

# Initiate databases
mysql_install_db -IN-RPM

# Change permissions again to fix any new files.
chown -R %{mysqld_user}:%{mysqld_user} $mysql_datadir

# Fix permissions for the permission database so that only the user
# can read them.
chmod -R og-rw $mysql_datadir/mysql

# Take care of info pages
/usr/sbin/htmlinfo_update.sh

# Restart in the same way that mysqld will be started normally.
/sbin/restart_maybe mysql

# Allow mysqld_safe to start mysqld and print a message before we exit
sleep 2

%preun
# Remove autostart of mysql
if test $1 = 0
then
   %{_initdir}/mysql stop > /dev/null
   /sbin/chkconfig --del mysql
fi
# We do not remove the mysql user since it may still own a lot of
# database files.

%postun
# Take care of info pages
/usr/sbin/htmlinfo_update.sh

%post libs
/sbin/ldconfig

%postun libs
/sbin/ldconfig

%files
%defattr(-,root,root)
%doc README COPYING COPYING.LIB Docs/mysqld_error.txt Docs/manual.txt
%doc Docs/manual.ps Docs/manual_toc.html Docs/manual.html
%doc support-files/*.cnf

/usr/bin/isamchk
/usr/bin/isamlog
/usr/bin/myisamchk
/usr/bin/myisamlog
/usr/bin/myisampack
/usr/bin/mysql_fix_privilege_tables
/usr/bin/mysql_convert_table_format
/usr/bin/mysql_install
/usr/bin/mysql_install_db
/usr/bin/mysql_setpermission
/usr/bin/mysql_zap
/usr/bin/mysqlbug
/usr/bin/mysqltest
/usr/bin/mysqlhotcopy
/usr/bin/mysqlmanager
/usr/bin/pack_isam
/usr/bin/perror
/usr/bin/replace
/usr/bin/resolveip
/usr/bin/mysqld_safe
/usr/bin/mysql_explain_log
/usr/bin/mysql_fix_extensions
/usr/bin/mysql_secure_installation
/usr/bin/resolve_stack_dump
/usr/bin/mysqld_multi
/usr/bin/my_print_defaults

/usr/share/html/%{name}

/usr/sbin/mysqld

/etc/logrotate.d/mysql
%{_initdir}/mysql
%dir %attr(700, %{mysqld_user}, %{mysqld_user}) /var/lib/mysql
%dir %attr(700, %{mysqld_user}, %{mysqld_user}) /var/lib/mysql/mysql
/usr/share/mysql/

%{_mandir}/man1/isamchk.1*
%{_mandir}/man1/isamlog.1*
%{_mandir}/man1/mysql_fix_privilege_tables.1*
%{_mandir}/man1/mysql_zap.1*
%{_mandir}/man1/mysqld.1*
%{_mandir}/man1/mysqld_multi.1*
%{_mandir}/man1/mysqld_safe.1*
%{_mandir}/man1/perror.1*
%{_mandir}/man1/replace.1*

%files client
%defattr(-,root,root)
/usr/bin/msql2mysql
/usr/bin/mysql
/usr/bin/mysqlaccess
/usr/bin/mysql_find_rows
/usr/bin/mysqldump
/usr/bin/mysqlimport
/usr/bin/mysqlshow
/usr/bin/mysqlbinlog
/usr/bin/mysql_waitpid
/usr/bin/mysqlcheck

%{_mandir}/man1/mysql.1*
%{_mandir}/man1/mysqlaccess.1*
%{_mandir}/man1/mysqladmin.1*
%{_mandir}/man1/mysqldump.1*
%{_mandir}/man1/mysqlshow.1*

%files devel
%defattr(-,root,root)
/usr/lib/*.a
/usr/lib/*.la
/usr/lib/*.so
/usr/bin/comp_err
/usr/include/mysql/
/usr/lib/mysql/
/usr/bin/mysql_config

%files libs
%defattr(-,root,root)
/usr/lib/*.so.*

%files shared
%defattr(-,root,root)
/usr/bin/mysqladmin
%config(noreplace) %attr(600, root, root) /etc/my.cnf
/usr/bin/mysql_tableinfo
/usr/bin/mysqldumpslow

%files bench
%defattr(-,root,root)
/usr/share/sql-bench
/usr/share/mysql-test
/usr/bin/mysqlmanager-pwgen
/usr/bin/mysqlmanagerc

%changelog 
* Thu Mar 17 2005 Erlend Midttun <erlendbm at trustix dot org> 4.0.24-1tr
- Stefano Di Paola discovered three bugs in MySQL:

  MySQL 4.0.23 and earlier, and 4.1.x up to 4.1.10, allows remote
  authenticated users with INSERT and DELETE privileges to execute
  arbitrary code by using CREATE FUNCTION to access libc calls,
  as demonstrated by using strcat, on_exit, and exit. 
  The Common Vulnerabilities and Exposures project (cve.mitre.org) has
  assigned the name CAN-2005-0709 to this issue.


  MySQL 4.0.23 and earlier, and 4.1.x up to 4.1.10, allows remote
  authenticated users with INSERT and DELETE privileges to bypass
  library path restrictions and execute arbitrary libraries by using
  INSERT INTO to modify the mysql.func table, which is processed by the
  udf_init function.

  The Common Vulnerabilities and Exposures project (cve.mitre.org) has
  assigned the name CAN-2005-0710 to this issue.


  MySQL 4.0.23 and earlier, and 4.1.x up to 4.1.10, uses predictable file
  names when creating temporary tables, which allows local users with
  CREATE TEMPORARY TABLE privileges to overwrite arbitrary files via a
  symlink attack.

  The Common Vulnerabilities and Exposures project (cve.mitre.org) has
  assigned the name CAN-2005-0711 to this issue.

* Thu Oct 14 2004 Oystein Viggen <oysteivi at trustix dot com> 4.0.21-1tr
- New upstream

* Wed Sep 29 2004 Oystein Viggen <oysteivi at trustix dot com>
- Patch tempfile issue 

* Thu Feb 19 2004 Omar Kilani <ok at trustix dot org> 4.0.18-1ok
- New upstream.

* Thu Dec 18 2003 Erlend Midttun <erlendbm at trustix dot com> 4.0.17-1tr
- New upstream.

* Thu Nov 27 2003 Erlend Midttun <erlendbm at trustix dot com> 4.0.16-2tr
- Big rebuild.

* Tue Oct 11 2003 Tor Hveem <torh at trustix dot org> 4.0.16-1th
- New upstream version

* Tue Sep 16 2003 Chr. H. Toldnes <christht at trustix dot com> 4.0.15-3tr
- Rebuilt and retagged for release.

* Tue Sep 10 2003 Goetz Bock <bock at trustix dot org> 4.0.15-2bg
- cleaned up the spec file
- made /etc/my.cnf a noreplace
- commented all the debug stuff out, it's not build anyway
  (look for [bg])
- included static libs into -devel
- fixed init file to be more userfriendly

* Tue Sep 10 2003 Goetz Bock <bock at trustix dot org> 4.0.15-1bg
- new upstream: 4.0.15 to fix security bug

* Tue Aug 26 2003 Erlend Midttun <erlendbm at trustix dot com> 4.0.14-2tr
- Tried to intergrate the changes from 4.0.13-4bg.

* Fri Aug 15 2003 Erlend Midttun <erlendbm at trustix dot com> 4.0.14-1tr
- New upstream with the usual bunch of fixes.
- Add SSL support.

* Mon Jun 23 2003 Erlend Midttun <erlendbm at trustix dot com> 4.0.13-3tr
- Added %defattr.

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 4.0.13-2tr
- Big rebuild.

* Fri May 23 2003 Tor Hveem <torh at trustix dot org> 4.0.13-1th
- 4.0.13

* Mon Apr 28 2003 Erlend Midttun <erlendbm at trustix dot com> 4.0.12-2em
- Fixed init script.

* Mon Apr 28 2003 Erlend Midttun <erlendbm at trustix dot com> 4.0.12-1em
- Upgraded to 4.0.12.

* Mon Mar 31 2003 Erlend Midttun <erlendbm at trustix dot com> 3.23.56-5em
- Fix broken htmlinfo line.

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 3.23.56-4em
- Rebuilt against glibc 2.3.2.

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 3.23.56-3em
- Add mysql group.
- Moved mysql socket to /var/run/mysql/mysql.sock
- Made /var/lib/mysql mode 700.

* Thu Mar 20 2003 Erlend Midttun <erlendbm at trustix dot com> 3.23.56-2em
- Cleanup.

* Wed Mar 19 2003 Erlend Midttun <erlendbm at trustix dot com> 3.23.56-1em
- New upstream to fix sec hole.
- Now make info files.

* Sun Mar  9 2003 Gerald Dachs <gda at trustix dot org> 3.23.55-3gd
- cleaned up init script

* Fri Feb 28 2003 Erlend Midttun <erlendbm at trustix dot com> 3.23.55-2em
- Added config file.
- Moved *.so to devel.

* Tue Feb 25 2003 Erlend Midttun <erlendbm at trustix dot com> 3.23.55-1em
- Added mysqladmin to
- Removed info files.  Should really figure out how to convert it.

* Sat Jan 18 2003 Gerald Dachs <gda at trustix dot org> 3.23.54a-4gd
- didn't clean build root

* Thu Jan  9 2003 Erlend Midttun <erlendbm at trustix dot com> 3.23.54a-3em
- shared -> libs

* Thu Jan  9 2003 Erlend Midttun <erlendbm at trustix dot com> 3.23.54a-2em
- Use _initdir macro

* Tue Dec 17 2002 Erlend Midttun <erlendbm at trustix dot com>
- Upgraded to fix security holes.

* Fri Mar 15 2002 Christian H. Toldnes <christht at trustix dot com>
- Rebuild on new zlib, due to broken old one.

* Fri Jan  4 2002 Christian H. Toldnes <christht at trustix dot com>
- New upstream version: 3.23.47
- Now calls stop only once on upgrade.
- Added %clean, general package cleanup.

* Tue Jun  5 2001 Oystein Viggen <oysteivi at trustix dot com>
- New upstream version: 3.23.28

* Wed Mar 28 2001 Alexander Reelsen <ar at trustix dot com>
- Updated to 3.23.36, security fix

* Mon Mar 26 2001 Alexander Reelsen <ar at trustix dot com>
- Fixed init script problems

* Mon Feb 19 2001 Oystein Viggen <oysteivi at trustix dot com>
- Adapt to TSL

* Tue Jan 2  2001  Monty

- Added mysql-test to the bench package

* Fri Aug 18 2000 Tim Smith <tim@mysql.com>

- Added separate libmysql_r directory; now both a threaded
  and non-threaded library is shipped.

* Wed Sep 28 1999 David Axmark <davida@mysql.com>

- Added the support-files/my-example.cnf to the docs directory.

- Removed devel dependency on base since it is about client
  development.

* Wed Sep 8 1999 David Axmark <davida@mysql.com>

- Cleaned up some for 3.23.

* Thu Jul 1 1999 David Axmark <davida@mysql.com>

- Added support for shared libraries in a separate sub
  package. Original fix by David Fox (dsfox@cogsci.ucsd.edu)

- The --enable-assembler switch is now automatically disables on
  platforms there assembler code is unavailable. This should allow
  building this RPM on non i386 systems.

* Mon Feb 22 1999 David Axmark <david@detron.se>

- Removed unportable cc switches from the spec file. The defaults can
  now be overridden with environment variables. This feature is used
  to compile the official RPM with optimal (but compiler version
  specific) switches.

- Removed the repetitive description parts for the sub rpms. Maybe add
  again if RPM gets a multiline macro capability.

- Added support for a pt_BR translation. Translation contributed by
  Jorge Godoy <jorge@bestway.com.br>.

* Wed Nov 4 1998 David Axmark <david@detron.se>

- A lot of changes in all the rpm and install scripts. This may even
  be a working RPM :-)

* Sun Aug 16 1998 David Axmark <david@detron.se>

- A developers changelog for MySQL is available in the source RPM. And
  there is a history of major user visible changed in the Reference
  Manual.  Only RPM specific changes will be documented here.
